searchNodes=[{"doc":"A NIF-based immutable array, based on a 'Relaxed Radix Balanced Trie Vector'. This Elixir module wraps the vector exposed by the Rust library im . This is a persistent vector datastructure that contains the following optimizations: Smart head/tail chunking The ability to do updates in-place when there is only one owner of a particular (part of a) vector. Most operations run either in O(1), amortized O(1), or O(log64(n)). Dealing with NIFs Because this library is implemented in Rust code, wrapped by a bunch of 'Natively Implemented Function's, using the Rustler library for interop, there are some things to keep in mind: This module does not support hot-code reloading. (NIFs can theoretically support it, but Rustler currently does not ) The arrays created in this module support all Elixir/Erlang terms. For most terms this is performant. Because of limitations of the NIF interface, storing/reading the following terms to/from arrays has a bit more overhead: References Functions Integers which are larger than what fits in a 64-bit signed number. Ports","ref":"ArraysRRBVector.html","title":"ArraysRRBVector","type":"module"},{"doc":"Appends an element to an RRBVector.","ref":"ArraysRRBVector.html#append/2","title":"ArraysRRBVector.append/2","type":"function"},{"doc":"","ref":"ArraysRRBVector.html#append_impl/2","title":"ArraysRRBVector.append_impl/2","type":"function"},{"doc":"Returns an empty RRBVector. iex&gt; ArraysRRBVector.empty() #ArraysRRBVector&lt;[]&gt;","ref":"ArraysRRBVector.html#empty/0","title":"ArraysRRBVector.empty/0","type":"function"},{"doc":"","ref":"ArraysRRBVector.html#extract/1","title":"ArraysRRBVector.extract/1","type":"function"},{"doc":"","ref":"ArraysRRBVector.html#extract_impl/1","title":"ArraysRRBVector.extract_impl/1","type":"function"},{"doc":"","ref":"ArraysRRBVector.html#get/2","title":"ArraysRRBVector.get/2","type":"function"},{"doc":"Maps a value over a vector, returning another vector. Note that the current implementation is relatively slow, as we turn the whole vector in a list, map over this list, and then turn the list back into a vector. A more effient implementation is probably possible, but a bit tricky to write. (PR's welcome! 😉)","ref":"ArraysRRBVector.html#map/2","title":"ArraysRRBVector.map/2","type":"function"},{"doc":"","ref":"ArraysRRBVector.html#new/1","title":"ArraysRRBVector.new/1","type":"function"},{"doc":"","ref":"ArraysRRBVector.html#reduce/3","title":"ArraysRRBVector.reduce/3","type":"function"},{"doc":"","ref":"ArraysRRBVector.html#reduce_right/3","title":"ArraysRRBVector.reduce_right/3","type":"function"},{"doc":"","ref":"ArraysRRBVector.html#replace/3","title":"ArraysRRBVector.replace/3","type":"function"},{"doc":"","ref":"ArraysRRBVector.html#resize/3","title":"ArraysRRBVector.resize/3","type":"function"},{"doc":"The number of elements in vector . iex&gt; ArraysRRBVector.size(ArraysRRBVector.empty()) 0 iex&gt; ArraysRRBVector.size(ArraysRRBVector.append(ArraysRRBVector.empty(), 42)) 1","ref":"ArraysRRBVector.html#size/1","title":"ArraysRRBVector.size/1","type":"function"},{"doc":"Extracts a contiguous subsequence of elements from the RRBVector, and returns it as its own RRBVector. iex&gt; ArraysRRBVector.new(1..10) |&gt; ArraysRRBVector.slice(2, 3) #ArraysRRBVector&lt;[3, 4, 5]&gt;","ref":"ArraysRRBVector.html#slice/3","title":"ArraysRRBVector.slice/3","type":"function"},{"doc":"","ref":"ArraysRRBVector.html#to_list/1","title":"ArraysRRBVector.to_list/1","type":"function"},{"doc":"","ref":"ArraysRRBVector.html#t:t/0","title":"ArraysRRBVector.t/0","type":"type"}]